<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"] ?: array()) + array("_dbbe14f567693a631f8a43b65af91" . "7ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCB" . "mcm9tIGRhdGFiYXNlOiBvYm" . "plY3QgY29kZSBub3Qgc3BlY" . "2lmaWVk"), "_80fc2a45acd015" . "0df87d1fb728940" . "a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJf" . "aWQ9aW50OnVpZA=="), "_84718d828d2acc3c366f9" . "6b07e841f6a" => base64_decode("YWNsLnNp" . "bXBsZQ=="), "_938704c" . "4c0169c3" . "804d4bd6" . "aa9941a7" . "6" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCB" . "jb2RlIG5vdCBzcGVjaWZpZWQ="), "_ef2948c87ef" . "38aab9226e41" . "189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3Rf" . "Y29kZSBlcTpzdHI6Y29kZQ=="), "_b06968b9268deaf3b380bd" . "0fe922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6" . "Y29kZSBBTkQgdXNlcl9pZD1pbnQ6dWlk"), "_0877a0b48cf424a0de57a45" . "3ce95e30c" => base64_decode("aW50OnV" . "zZXJfaW" . "Q="), "_a7ed4d7408bb99b87a09d" . "89d4212d5de" => base64_decode("c2ltcGxlX2Fj" . "bA=="), "_a8b22fedb27a1" . "1e07f5bb9a7c73" . "608ea" => base64_decode("c3RyKDEwM" . "Ck6b2JqZW" . "N0X2NvZGU" . "="), "_27de5a45" . "db71bf240" . "58769b61b" . "3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVj" . "dCBjb2RlIG5vdCBzcGVjaWZpZWQ="), "_c95cbc316178c97" . "697a403f4d912410" . "6" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZW" . "N0X2NvZGUgZXE6c3RyOmNvZGU="), "_3cda3f34" . "ada928e4a" . "a39d4629c" . "5504aa" => base64_decode("aW50On" . "JpZ2h0" . "cw=="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_84718d828d2" . "acc3c366f96b" . "07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_80fc2a45acd0150df87d1f" . "b728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_a7ed4d7" . "408bb99b" . "87a09d89" . "d4212d5d" . "e"], [$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_a8b22fedb27" . "a11e07f5bb9a" . "7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_0877a0b48cf424a" . "0de57a453ce95e30" . "c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_3cda3f34ada928e4aa39" . "d4629c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_b06968b9268deaf" . "3b380bd0fe922b45" . "3"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_938704c4c0169c3804d4" . "bd6aa9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_c95cbc316178" . "c97697a403f4d" . "9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_27de5a45db71bf240587" . "69b61b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_dbbe14f567693a631f8a43b65af91" . "7ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_ef2948c87ef38aab9226e41189b" . "29ca7"], $acl->GetObjectCode());
    }
}